<template>
  <div class="app-container">
    <el-card>
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="88px">
        <el-form-item label="开始时间" prop="startTime">
          <el-date-picker clearable
                          popper-class="picker-dateNoneYear"
                          v-model="queryParams.startTime"
                          type="date"
                          format="MM月dd日"  value-format="MM-dd"
                          placeholder="请选择开始时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>

      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['app:ratio:add']"
          >新增</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['app:ratio:remove']"
          >删除</el-button>
        </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
    </el-card>
    <br>
    <el-card>
      <el-table border stripe  v-loading="loading" :data="ratioList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55"  />
        <el-table-column label="干损比例（%）"  prop="dryLossRatio" />
        <el-table-column label="开始时间"  prop="startTime">
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.startTime, '{m}月{d}日') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="是否启用"  prop="isUse">
          <template slot-scope="scope">
            <el-tag v-if="scope.row.isUse === 0" type="danger">未启用</el-tag>
            <el-tag v-else-if="scope.row.isUse === 1">已启用</el-tag>
          </template>
        </el-table-column>
        <el-table-column label="操作" width="180"  class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleView(scope.row)"
            >查看</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['app:ratio:edit']"
            >修改</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDelete(scope.row)"
              v-hasPermi="['app:ratio:remove']"
            >删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </el-card>

    <!-- 添加或修改干损比例对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" label-position="left" :model="form" :rules="rules" :disabled="isView" label-width="140px">
        <el-form-item label="干损比例（%）" prop="dryLossRatio">
          <el-input v-model="form.dryLossRatio" placeholder="请输入干损比例" />
        </el-form-item>
        <el-form-item label="开始时间" prop="startTime">
          <el-date-picker clearable
            popper-class="picker-dateNoneYear"
            v-model="form.startTime"
            type="date"
            format="MM月dd日"
            placeholder="请选择开始时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="是否启用" prop="isUse">
          <el-radio-group v-model="form.isUse">
            <el-radio :label="0">未启用</el-radio>
            <el-radio :label="1">已启用</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!isView">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listRatio, getRatio, delRatio, addRatio, updateRatio } from "@/api/app/dryLossRatio";

export default {
  name: "Ratio",
  data() {
    var valiRadio = (rule, value, callback) => {//包含小数的数字
            let reg = /^(0?\.(0[1-9]|[1-9]\d?)|[1-9]\d{0,1}(\.\d{1,2})?)$/;;
            if (value === '') {
                callback(new Error('干损比例不能为空'));
            } else if (!reg.test(value)) {
                callback(new Error('干损比例输入超出设定范围限制（0.01~99.99）,保留两位小数'));
            } else {
                callback();
            }
        };
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 干损比例表格数据
      ratioList: [],
      // 弹出层标题
      title: "",
      isView:false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        startTime: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        dryLossRatio: [
          { required: true, message: "干损比例不能为空", trigger: "blur" },
          { validator: valiRadio, trigger: "blur" },
        ],
        startTime: [
          { required: true, message: "开始时间不能为空", trigger: "blur" }
        ],
        isUse: [
          { required: true, message: "是否启用不能为空", trigger: "blur" }
        ]
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询干损比例列表 */
    getList() {
      // this.loading = false;
      this.loading = true;
      listRatio(this.queryParams).then(response => {
        this.ratioList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        dryLossRatio: null,
        startTime: null,
        startTimeCut:null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.isView = false;
      this.title = "添加干损比例";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getRatio(id).then(response => {
        this.form = response.data;
        this.form.dryLossRatio = this.form.dryLossRatio?parseFloat(this.form.dryLossRatio).toFixed(2):0;
        this.open = true;
        this.isView = false;
        this.title = "修改干损比例";
      });
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.reset();
      const id = row.id || this.ids
      getRatio(id).then(response => {
        this.form = response.data;
        this.form.dryLossRatio = this.form.dryLossRatio?parseFloat(this.form.dryLossRatio).toFixed(2):0;
        this.open = true;
        this.isView = true;
        this.title = "查看干损比例";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        this.form.dryLossRatio = this.form.dryLossRatio?parseFloat(this.form.dryLossRatio).toFixed(2):0;
        this.form.startTime = this.parseTime(this.form.startTime, '{m}-{d}')
        if (valid) {

          if (this.form.id != null) {
            updateRatio(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRatio(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除所选数据项？').then(function() {
        return delRatio(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('app/ratio/export', {
        ...this.queryParams
      }, `ratio_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>

<style lang="scss">
  /*选择日期，年份的隐藏 */
  .picker-dateNoneYear {
    .el-date-picker__header {
      span:nth-child(3) { /*第三个标签是span的标签，把它隐藏*/
        display: none;
      }
      button:nth-child(1) {
        display: none;
      }
      button:nth-child(5) {
        display: none;
      }
    }
  }
</style>
